precision highp float;

varying highp vec2 uTexCoord;

uniform int uInterpolate;
uniform highp float uRatio;

uniform sampler2D prevTexture;
uniform sampler2D nextTexture;
uniform sampler2D mapTexture;

uniform highp vec2 uResolution;

#define PI 3.1415926535898

void main() {
    if (uInterpolate == 1) {
        vec2 map = texture2D(mapTexture, uTexCoord).rg / uResolution;
        vec4 prev_color = texture2D(prevTexture, uTexCoord + map * uRatio);
        vec4 next_color = texture2D(nextTexture, uTexCoord - map * (1.0 - uRatio));

        float blend = -(cos(PI * uRatio) - 1.0) / 2.0;
        gl_FragColor = prev_color * (1.0 - blend) + next_color * blend;
    } else {
        gl_FragColor = texture2D(prevTexture, uTexCoord);
    }
}


